@ffIco: ~'ico';

@font-face {
  font-family: '@{ffIco}';
  src: url('@{ffIco}.eot');
  src: url('@{ffIco}.eot?#iefix') format('eot'),
       url('@{ffIco}.woff2') format('woff2'),
       url('@{ffIco}.woff') format('woff'),
       url('@{ffIco}.ttf') format('truetype');
  font-weight: normal;
  font-style: normal;
}

.ico-char(@filename) {
  @user: "\E001";
  @download: "\E002";
  @gear: "\E003";
  @login: "\E004";
  @logout: "\E005";
  @book: "\E006";
  @file: "\E007";
  @database: "\E008";
  @sitemap: "\E009";
  @speech-bubble: "\E00A";
  @cursor: "\E00B";
  @control-panel: "\E00C";
  @generation: "\E00D";
  @window: "\E00E";
  @windows-os: "\E00F";
  @computer: "\E010";
  @apple-os: "\E011";
  @android-os: "\E012";
  @play: "\E013";
  @network: "\E014";
  @equalizer: "\E015";
  @facebook: "\E016";
  @linkedin: "\E017";
  @twitter: "\E018";
  @google-plus: "\E019";
  
  content: @@filename;
}

.icoProperties() {
  display: block;
  font-family: @ffIco;
  line-height: 1;
  font-style: normal;
  font-variant: normal;
  font-weight: normal;
  font-feature-settings: 'liga';
  text-decoration: none;
  text-transform: none;
  text-rendering: optimizeLegibility;
  letter-spacing: normal;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

.ico(@filename, @insert: before) {
  @pseudo-selector: ~":@{insert}";

  &@{pseudo-selector} {
    .ico-char(@filename);
    .icoProperties;
  }
}

  .ico.user:before,
  [data-ico="user"]:before {
    content: "\E001";
    .icoProperties;
  }

  .ico.download:before,
  [data-ico="download"]:before {
    content: "\E002";
    .icoProperties;
  }

  .ico.gear:before,
  [data-ico="gear"]:before {
    content: "\E003";
    .icoProperties;
  }

  .ico.login:before,
  [data-ico="login"]:before {
    content: "\E004";
    .icoProperties;
  }

  .ico.logout:before,
  [data-ico="logout"]:before {
    content: "\E005";
    .icoProperties;
  }

  .ico.book:before,
  [data-ico="book"]:before {
    content: "\E006";
    .icoProperties;
  }

  .ico.file:before,
  [data-ico="file"]:before {
    content: "\E007";
    .icoProperties;
  }

  .ico.database:before,
  [data-ico="database"]:before {
    content: "\E008";
    .icoProperties;
  }

  .ico.sitemap:before,
  [data-ico="sitemap"]:before {
    content: "\E009";
    .icoProperties;
  }

  .ico.speech-bubble:before,
  [data-ico="speech-bubble"]:before {
    content: "\E00A";
    .icoProperties;
  }

  .ico.cursor:before,
  [data-ico="cursor"]:before {
    content: "\E00B";
    .icoProperties;
  }

  .ico.control-panel:before,
  [data-ico="control-panel"]:before {
    content: "\E00C";
    .icoProperties;
  }

  .ico.generation:before,
  [data-ico="generation"]:before {
    content: "\E00D";
    .icoProperties;
  }

  .ico.window:before,
  [data-ico="window"]:before {
    content: "\E00E";
    .icoProperties;
  }

  .ico.windows-os:before,
  [data-ico="windows-os"]:before {
    content: "\E00F";
    .icoProperties;
  }

  .ico.computer:before,
  [data-ico="computer"]:before {
    content: "\E010";
    .icoProperties;
  }

  .ico.apple-os:before,
  [data-ico="apple-os"]:before {
    content: "\E011";
    .icoProperties;
  }

  .ico.android-os:before,
  [data-ico="android-os"]:before {
    content: "\E012";
    .icoProperties;
  }

  .ico.play:before,
  [data-ico="play"]:before {
    content: "\E013";
    .icoProperties;
  }

  .ico.network:before,
  [data-ico="network"]:before {
    content: "\E014";
    .icoProperties;
  }

  .ico.equalizer:before,
  [data-ico="equalizer"]:before {
    content: "\E015";
    .icoProperties;
  }

  .ico.facebook:before,
  [data-ico="facebook"]:before {
    content: "\E016";
    .icoProperties;
  }

  .ico.linkedin:before,
  [data-ico="linkedin"]:before {
    content: "\E017";
    .icoProperties;
  }

  .ico.twitter:before,
  [data-ico="twitter"]:before {
    content: "\E018";
    .icoProperties;
  }

  .ico.google-plus:before,
  [data-ico="google-plus"]:before {
    content: "\E019";
    .icoProperties;
  }
